﻿using Contracts.BindingModels;
using Contracts.ViewModels;
using DataModels.Models;
using System;
using System.Collections.Generic;

namespace DataBase;

/// <summary>
/// Таблица статусов
/// </summary>
public partial class Status : IStatus
{
    /// <summary>
    /// Айди статуса
    /// </summary>
    public int Id { get; set; }

    /// <summary>
    /// Название статуса
    /// </summary>
    public string? Title { get; set; } = string.Empty;

    public virtual ICollection<Car> Cars { get; set; } = new List<Car>();

    public virtual ICollection<Company> Companies { get; set; } = new List<Company>();

    public virtual ICollection<Human> Humans { get; set; } = new List<Human>();
    public static Status Create(LogisticContext context, StatusBM model)
    {
        return new Status()
        {
            Id = model.Id,
            Title = model.Title,
            

        };
    }

    public void Update(StatusBM model)
    {
        Title = model.Title;


    }

    public StatusVM GetViewModel => new()
    {
        Id = Id,
        Title = Title,
        
    };
}
