﻿// See https://aka.ms/new-console-template for more information
using Contracts.BindingModels;
using Contracts.SearchModel;
using DataBase;
using Microsoft.Extensions.DependencyInjection;
using MongoDB;
using MongoDB.Driver;
using System;
using System.Data;
using System.Reflection.Metadata.Ecma335;

MongoDB.StatusStorage statusStorageMongo = new();
DataBase.LogisticContext logisticContext = new();
DataBase.Implements.StatusStorage statusStoragePost = new();

    Console.WriteLine("start Status");
    foreach (var status in logisticContext.Statuses.ToList())
    {
        if (statusStorageMongo.GetElement(new StatusSM { Title = status.Title }) == null)
        {
            statusStorageMongo.Insert(new StatusBM { Title = status.Title });
        }
    }
    Console.WriteLine("finish Status");
    MongoDB.HumanStorage humanStorageMongo = new();
    Console.WriteLine("start human");
    foreach (var human in logisticContext.Humans.ToList())
    {
        if (humanStorageMongo.GetElement(new HumanSM { Phone = human.Phone }) == null)
        {
            humanStorageMongo.Insert(new HumanBM { Name = human.Name, StatusTitle = human.Status.Title, Phone = human.Phone , number = human.Id});
        }
    }
    Console.WriteLine("finish Human");
    MongoDB.CompanyStorage companyStorageMongo = new();
    Console.WriteLine("start Company");
    foreach (var company in logisticContext.Companies.ToList())
    {
        if (companyStorageMongo.GetElement(new CompanySM { Title = company.Title }) == null)
        {
            companyStorageMongo.Insert(new CompanyBM { Title = company.Title, StatusTitle = company.Status.Title });
        }
    }
    Console.WriteLine("finish Company");
    MongoDB.CarStorage carStorageMongo = new();
    Console.WriteLine("start car");
    foreach (var car in logisticContext.Cars.ToList())
    {
        if (carStorageMongo.GetElement(new CarSM { Model = car.Model }) == null)
        {
            carStorageMongo.Insert(new CarBM { number = car.Id.ToString(), Model = car.Model, Tonnage = car.Tonnage, StatusTitle = car.Status.Title });
        }
    }
    Console.WriteLine("finish Car");
    MongoDB.PlaceStorage placeStorageMongo = new();
    Console.WriteLine("start place");
    foreach (var place in logisticContext.Places.ToList())
    {
        if (placeStorageMongo.GetElement(new PlaceSM { Title = place.Title }) == null)
        {
            placeStorageMongo.Insert(new PlaceBM { Title = place.Title });
        }
    }
    Console.WriteLine("finish Place");
    MongoDB.RouteStorage routeStorageMongo = new();
    Console.WriteLine("start route");
    foreach (var route in logisticContext.Routes.ToList())
    {
        if (routeStorageMongo.GetElement(new RouteSM { Title = route.PlaceStartNavigation.Title + "-" + route.PlaceEndNavigation.Title }) == null)
        {
            routeStorageMongo.Insert(new RouteBM { Title = route.PlaceStartNavigation.Title + "-" + route.PlaceEndNavigation.Title, Length = route.Length, PlaceStartName = route.PlaceStartNavigation.Title, PlaceEndName = route.PlaceEndNavigation.Title });
        }
    }
    Console.WriteLine("finish Route");
    MongoDB.VoyageStorage voyageStorageMongo = new();
    Console.WriteLine("start voyage");
    foreach (var voyage in logisticContext.Voyages.ToList())
    {
        voyageStorageMongo.Insert(new VoyageBM { CarName = voyage.Car.Model, CompanyName = voyage.Company.Title, HumanName = voyage.Human.Name, RouteName = voyage.Route.Title, DateStart = voyage.DateStart, DateEnd = voyage.DateEnd });
    }
    Console.WriteLine("finish Voyage");
